package initialize

import (
	"github.com/minio/minio-go/v7"
	"github.com/minio/minio-go/v7/pkg/credentials"
)

func Minio(cfg Config) (*minio.Client, error) {
	conn, err := minio.New(cfg.S3Endpoint,
		&minio.Options{
			Creds:  credentials.NewStaticV4(cfg.S3AccessKey, cfg.S3SecretKey, cfg.S3Token),
			Secure: cfg.IsProd,
		},
	)
	if err != nil {
		return nil, err
	}

	return conn, nil
}
